<template>
  <div class="p-4">
    <div class="breadcrumbs">
      <ul>
        <li><NuxtLink to="/">Home</NuxtLink></li>
        <li>{{ (place && place.name) ? place.name : '' }}</li>
      </ul>
    </div>

    <hr class="my-4" />

    <div class="w-full">
      <div class="tabs">
        <a
          v-for="tab in tabs"
          :key="tab.id"
          :class="{
            tab: true,
            'tab-lifted': true,
            'tab-active': tab.id === tabActive,
          }"
          @click="() => {tabActive = tab.id}"
        >
          {{ tab.title }}
        </a>
      </div>

      <div class="p-4">
        <TabsTabOverView v-if="tabActive === 1 && place" :place="place" />
        <TabsTabReviews v-if="tabActive === 2" :reviews="place.reviews" />
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
const route = useRoute()
const loading = ref(false)
const place = ref({})
const colorMode = useColorMode()

const tabActive = ref(1)
const tabs = [
  { id: 1, title: 'overview' },
  { id: 2, title: 'reviews' },
]

type Place = {
  business_status: string
  name: string
  location: Array<{
    lat: number
    lng: number
  }>
  photos: Array<{
    reference: string
    height: number
    width: number
  }>
  place_id: string
  rating: string
  reference: string
  formatted_address: string
  current_opening_hours: string
  website: string
  formatted_phone_number: string
  reviews: Array<Reviews>
}

type Reviews = {
  author_name: string
}

type RestaurantDetailResponse = {
  results: Place
  statusCode: number
}

const loadPlace = (id: string): void => {
  loading.value = true

  $fetch(`/api/restaurants/${id}`)
  .then((items: RestaurantDetailResponse) => {
    loading.value = false
    place.value = items.results
  })
}

onMounted(() => {
  loadPlace(route.params.id)
})
</script>
